Index: reactapp/src/App.js
===================================================================
--- reactapp/src/App.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/App.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -12,30 +12,11 @@
 import AuthApi from "./api/AuthApi";
 import Cookies from "js-cookie";
-import axios from "./api/axios";
-import JSOG from "jsog";
 import NotFound from "./Pages/NotFound";
+import Topic from "./Pages/Topic";
 
 export default function App() {
   const [auth, setAuth] = useState(false);
-  const [user, setUser] = useState(null);
-  const [userLoaded, setUserLoaded] = useState(false);
   const variableAuth = useMemo(() => ({ auth, setAuth }), [auth]);
   const [authLoaded, setAuthLoaded] = useState(false);
-
-  const fetchUser = async () => {
-    try {
-      const response = await axios.get(
-        "http://192.168.0.17:8080/secure/currentUser",
-        { withCredentials: true }
-      );
-      var cyclicGraph = await response.data;
-      var jsogStructure = JSOG.encode(cyclicGraph);
-      cyclicGraph = JSOG.decode(jsogStructure);
-      setUser(cyclicGraph);
-      setUserLoaded(true);
-    } catch (error) {
-      console.log("Fetching error", error);
-    }
-  };
 
   const readCookie = async () => {
@@ -43,5 +24,4 @@
     if (session) {
       setAuth(true);
-      fetchUser();
     } else {
       setAuth(false);
@@ -51,4 +31,5 @@
 
   useEffect(() => {
+    document.title = "profesori.mk";
     readCookie();
   }, []);
@@ -69,26 +50,19 @@
       <BrowserRouter>
         <Routes>
-          <Route
-            path="/"
-            element={<Home user={user} userLoaded={userLoaded} />}
-          >
+          <Route path="/" element={<Home />}>
             <Route path="login" element={<Login />}></Route>
             <Route path="registration" element={<Registration />}></Route>
             <Route path="professor">
-              <Route
-                path=":professorId"
-                element={<Professor user={user} userLoaded={userLoaded} />}
-              />
+              <Route path=":professorId" element={<Professor />} />
             </Route>
             <Route path="university/:universityId" element={<University />} />
             <Route path="faculty/:facultyId" element={<Faculty />} />
             <Route path="subject/:subjectId" element={<Subject />} />
+            <Route path="topic/:topicId" element={<Topic />} />
             <Route path="search" element={<SearchResults />}></Route>
             <Route
               path="user_dashboard"
               element={
-                <ProtectedRoute auth={auth}>
-                  {<UserDashboard user={user} userLoaded={userLoaded} />}
-                </ProtectedRoute>
+                <ProtectedRoute auth={auth}>{<UserDashboard />}</ProtectedRoute>
               }
             ></Route>
Index: reactapp/src/Components/OpinionTree.js
===================================================================
--- reactapp/src/Components/OpinionTree.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/OpinionTree.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -3,5 +3,4 @@
   OpinionCardContent,
   OpinionCardContentTime,
-  OpinionCardContentTitle,
   OpinionReplyCard,
   OpinionReplyCardContent,
@@ -14,5 +13,6 @@
 import AuthApi from "../api/AuthApi";
 import { useNavigate } from "react-router-dom";
-import { useContext, useState } from "react";
+import { useContext, useState, useEffect } from "react";
+import JSOG from "jsog";
 import {
   Modal,
@@ -26,56 +26,82 @@
 import axios from "../api/axios";
 
-function OpinionTree({ professor, user, userLoaded }) {
+function OpinionTree({ professor }) {
   var renderedOpinionIds = [];
   var postCount; // za da ne go pokazuva ispod postot
 
+  const { auth, setAuth } = useContext(AuthApi);
   let navigate = useNavigate();
-  const { auth, setAuth } = useContext(AuthApi);
-
-  let [replyModalDisplay, setReplyModalDisplay] = useState("none");
+
+  const [replyModalDisplay, setReplyModalDisplay] = useState("none");
   const [replyContent, setReplyContent] = useState("");
-
   const [postForModal, setPostForModal] = useState(null);
+  const [user, setUser] = useState(null);
+  const [loadedUser, setLoadedUser] = useState(false);
+  const [fetchError, setFetchError] = useState(false);
+  const [errorMessage, setErrorMessage] = useState("");
+
+  useEffect(() => {
+    const url = `http://192.168.0.17:8080/secure/currentUser`;
+
+    const fetchUser = async () => {
+      try {
+        const response = await axios.get(url, { withCredentials: true });
+        var cyclicGraph = await response.data;
+        var jsogStructure = JSOG.encode(cyclicGraph);
+        cyclicGraph = JSOG.decode(jsogStructure);
+        setUser(cyclicGraph);
+        setLoadedUser(true);
+      } catch (error) {
+        setFetchError(true);
+      }
+    };
+
+    if (auth) fetchUser();
+  }, []);
 
   const handleLike = async (post) => {
-    if (
-      auth &&
-      userLoaded &&
-      !post.likes.some((e) => e.id === user.user.id) &&
-      !post.dislikes.some((e) => e.id === user.user.id)
-    ) {
-      const response = await axios(
-        `http://192.168.0.17:8080/secure/professor/${professor.professorId}/upvoteOpinion/${post.postId}`,
-        {
-          method: "get",
-          withCredentials: true,
-        }
-      );
-
-      window.location.reload(false);
+    if (auth) {
+      if (
+        loadedUser &&
+        user &&
+        !post.votes.some((e) => e.user.id === user.id)
+      ) {
+        const response = await axios(
+          `http://192.168.0.17:8080/secure/upvoteOpinion/${post.postId}`,
+          {
+            method: "get",
+            withCredentials: true,
+          }
+        );
+        window.location.reload(false);
+      } else {
+        return;
+      }
     } else {
-      return;
+      navigate("/login");
     }
   };
 
   const handleDislike = async (post) => {
-    if (
-      auth &&
-      auth &&
-      userLoaded &&
-      !post.likes.some((e) => e.id === user.user.id) &&
-      !post.dislikes.some((e) => e.id === user.user.id)
-    ) {
-      const response = await axios(
-        `http://192.168.0.17:8080/secure/professor/${professor.professorId}/downvoteOpinion/${post.postId}`,
-        {
-          method: "get",
-          withCredentials: true,
-        }
-      );
-
-      window.location.reload(false);
+    if (auth) {
+      if (
+        loadedUser &&
+        user &&
+        !post.votes.some((e) => e.user.id === user.id)
+      ) {
+        const response = await axios(
+          `http://192.168.0.17:8080/secure/downvoteOpinion/${post.postId}`,
+          {
+            method: "get",
+            withCredentials: true,
+          }
+        );
+
+        window.location.reload(false);
+      } else {
+        return;
+      }
     } else {
-      return;
+      navigate("/login");
     }
   };
@@ -101,17 +127,20 @@
     e.preventDefault();
 
-    const response = await axios(
-      `http://192.168.0.17:8080/secure/professor/${professor.professorId}/replyToOpinion/${postId}`,
-      {
-        method: "post",
-        body: {
-          content: replyContent,
-        },
-        withCredentials: true,
-      }
-    );
-
-    window.location.reload(false);
-    //console.log(response);
+    if (!replyContent.length < 1) {
+      const response = await axios(
+        `http://192.168.0.17:8080/secure/professor/${professor.professorId}/replyToOpinion/${postId}`,
+        {
+          method: "post",
+          data: {
+            content: replyContent,
+          },
+          withCredentials: true,
+        }
+      );
+      setErrorMessage("");
+      window.location.reload(false);
+    } else {
+      setErrorMessage("Полето за содржина не смее да биде празно");
+    }
   };
 
@@ -123,9 +152,11 @@
         <OpinionReplyCard indent={replyIndent + "px"}>
           <OpinionReplyCardContent>
-            <p>
-              <a href="#">{child.author.username}</a> му реплицирал на{" "}
-              {parentPostAuthorUsername}
+            <p style={{ fontStyle: "italic", marginBottom: "10px" }}>
+              <a href={"/user/" + child.author.id}>{child.author.username}</a>{" "}
+              му реплицирал на {parentPostAuthorUsername}
             </p>
-            <p>{child.content}</p>
+            <p style={{ marginBottom: "10px", maxWidth: "90%" }}>
+              {child.content}
+            </p>
             <OpinionReplyCardContentTime>
               {dateConverter(
@@ -133,36 +164,58 @@
               )}
             </OpinionReplyCardContentTime>
-            {auth && userLoaded && user.user.id !== child.author.id && (
-              <>
-                <StyledFontAwesomeIcon
-                  icon={solid("thumbs-up")}
-                  right={50 + "px"}
-                  color={
-                    child.likes.some((e) => e.id === user.user.id)
+
+            <div
+              style={{
+                display:
+                  !auth || (auth && loadedUser && user.id !== child.author.id)
+                    ? "block"
+                    : "none",
+              }}
+            >
+              <StyledFontAwesomeIcon
+                icon={solid("thumbs-up")}
+                right={50 + "px"}
+                color={
+                  auth && loadedUser && user
+                    ? child.votes.some(
+                        (e) => e.vote === "UPVOTE" && e.user.id === user.id
+                      )
                       ? "greenyellow"
                       : "darkgrey"
-                  }
-                  onClick={() => handleLike(child)}
-                />
-                <VoteCount right={50 + "px"}>{child.likes.length}</VoteCount>
-                <StyledFontAwesomeIcon
-                  icon={solid("thumbs-down")}
-                  right={10 + "px"}
-                  color={
-                    child.dislikes.some((e) => e.id === user.user.id)
+                    : "darkgrey"
+                }
+                onClick={() => handleLike(child)}
+              />
+
+              <VoteCount right={50 + "px"}>
+                {child.votes.filter((v) => v.vote === "UPVOTE").length}
+              </VoteCount>
+
+              <StyledFontAwesomeIcon
+                icon={solid("thumbs-down")}
+                right={10 + "px"}
+                color={
+                  auth && loadedUser && user
+                    ? child.votes.some(
+                        (e) => e.vote === "DOWNVOTE" && e.user.id === user.id
+                      )
                       ? "indianred"
                       : "darkgrey"
-                  }
-                  onClick={() => handleDislike(child)}
-                />
-                <VoteCount right={10 + "px"}>{child.dislikes.length}</VoteCount>
-                <StyledFontAwesomeIcon
-                  icon={solid("reply")}
-                  right={90 + "px"}
-                  color="darkgrey"
-                  onClick={() => handleReply(child)}
-                />
-              </>
-            )}
+                    : "darkgrey"
+                }
+                onClick={() => handleDislike(child)}
+              />
+
+              <VoteCount right={10 + "px"}>
+                {child.votes.filter((v) => v.vote === "DOWNVOTE").length}
+              </VoteCount>
+
+              <StyledFontAwesomeIcon
+                icon={solid("reply")}
+                right={90 + "px"}
+                color="darkgrey"
+                onClick={() => handleReply(child)}
+              />
+            </div>
           </OpinionReplyCardContent>
           {child.children.map((childOfChild) =>
@@ -187,11 +240,13 @@
               <OpinionCard>
                 <OpinionCardContent>
-                  <p>
-                    <a href="#">{opinion.author.username}</a> напишал
+                  <p style={{ fontStyle: "italic", marginBottom: "10px" }}>
+                    <a href={"/user/" + opinion.author.id}>
+                      {opinion.author.username}
+                    </a>{" "}
+                    напишал
                   </p>
-                  <OpinionCardContentTitle>
-                    {opinion.title}
-                  </OpinionCardContentTitle>
-                  <p>{opinion.content}</p>
+                  <p style={{ marginBottom: "10px", maxWidth: "90%" }}>
+                    {opinion.content}
+                  </p>
                   <OpinionCardContentTime>
                     {dateConverter(
@@ -199,40 +254,64 @@
                     )}
                   </OpinionCardContentTime>
-                  {auth && userLoaded && user.user.id !== opinion.author.id && (
-                    <>
-                      <StyledFontAwesomeIcon
-                        icon={solid("thumbs-up")}
-                        right={50 + "px"}
-                        color={
-                          opinion.likes.some((e) => e.id === user.user.id)
+
+                  <div
+                    style={{
+                      display:
+                        !auth ||
+                        (auth && loadedUser && user.id !== opinion.author.id)
+                          ? "block"
+                          : "none",
+                    }}
+                  >
+                    <StyledFontAwesomeIcon
+                      icon={solid("thumbs-up")}
+                      right={50 + "px"}
+                      color={
+                        auth && loadedUser && user
+                          ? opinion.votes.some(
+                              (e) =>
+                                e.vote === "UPVOTE" && e.user.id === user.id
+                            )
                             ? "greenyellow"
                             : "darkgrey"
-                        }
-                        onClick={() => handleLike(opinion)}
-                      />
-                      <VoteCount right={50 + "px"}>
-                        {opinion.likes.length}
-                      </VoteCount>
-                      <StyledFontAwesomeIcon
-                        icon={solid("thumbs-down")}
-                        right={10 + "px"}
-                        color={
-                          opinion.dislikes.some((e) => e.id === user.user.id)
+                          : "darkgrey"
+                      }
+                      onClick={() => handleLike(opinion)}
+                    />
+
+                    <VoteCount right={50 + "px"}>
+                      {opinion.votes.filter((v) => v.vote === "UPVOTE").length}
+                    </VoteCount>
+
+                    <StyledFontAwesomeIcon
+                      icon={solid("thumbs-down")}
+                      right={10 + "px"}
+                      color={
+                        auth && loadedUser && user
+                          ? opinion.votes.some(
+                              (e) =>
+                                e.vote === "DOWNVOTE" && e.user.id === user.id
+                            )
                             ? "indianred"
                             : "darkgrey"
-                        }
-                        onClick={() => handleDislike(opinion)}
-                      />
-                      <VoteCount right={10 + "px"}>
-                        {opinion.dislikes.length}
-                      </VoteCount>
-                      <StyledFontAwesomeIcon
-                        icon={solid("reply")}
-                        right={90 + "px"}
-                        color="darkgrey"
-                        onClick={() => handleReply(opinion)}
-                      />
-                    </>
-                  )}
+                          : "darkgrey"
+                      }
+                      onClick={() => handleDislike(opinion)}
+                    />
+
+                    <VoteCount right={10 + "px"}>
+                      {
+                        opinion.votes.filter((v) => v.vote === "DOWNVOTE")
+                          .length
+                      }
+                    </VoteCount>
+
+                    <StyledFontAwesomeIcon
+                      icon={solid("reply")}
+                      right={90 + "px"}
+                      color="darkgrey"
+                      onClick={() => handleReply(opinion)}
+                    />
+                  </div>
                 </OpinionCardContent>
                 {opinion.children.map((child) =>
@@ -243,4 +322,5 @@
           );
         }
+        return null;
       })}
       {postForModal && (
@@ -266,4 +346,9 @@
                 </label>
               </ModalBody>
+              <p
+                style={{ color: "red", marginLeft: "15px", marginTop: "10px" }}
+              >
+                {errorMessage}
+              </p>
               <ModalFooter type="submit">РЕПЛИЦИРАЈ</ModalFooter>
             </form>
Index: reactapp/src/Components/Styled/EntityList.style.js
===================================================================
--- reactapp/src/Components/Styled/EntityList.style.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/Styled/EntityList.style.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -18,5 +18,5 @@
 export const EntityParam = styled.p`
   position: absolute;
-  right: 30px;
+  right: ${(props) => props.right};
   top: 10px;
   font-style: italic;
Index: reactapp/src/Components/Styled/Modal.style.js
===================================================================
--- reactapp/src/Components/Styled/Modal.style.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/Styled/Modal.style.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -18,4 +18,5 @@
   float: right;
   font-weight: bold;
+  box-shadow: 2px 1px 10px #aaaaaa;
 `;
 
Index: reactapp/src/Components/Styled/OpinionCard.style.js
===================================================================
--- reactapp/src/Components/Styled/OpinionCard.style.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/Styled/OpinionCard.style.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -18,4 +18,5 @@
   }
   position: relative;
+  overflow-wrap: break-word;
 `;
 
@@ -55,4 +56,5 @@
   display: block;
   position: absolute;
+  height: 20px;
   top: 50%;
   transform: translateY(-50%);
@@ -60,5 +62,5 @@
   transition: 0.5s;
   &:hover {
-    color: ${(props) => props.color};
+    opacity: 0.5;
     cursor: pointer;
   }
Index: reactapp/src/Components/SubjectsAccordion.js
===================================================================
--- reactapp/src/Components/SubjectsAccordion.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/SubjectsAccordion.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -27,56 +27,57 @@
       <SubjectsAccordionDiv height={height} opacity={opacity}>
         <EntityUl>
-          {props.content.map((item) => {
-            let totalPosts = item.threads.length;
-            return (
-              <EntityLi key={item.subjectName} bgcolor="cornsilk">
-                <a href={"/subject/" + item.subjectId}>{item.subjectName}</a>
-                <EntityParam>
-                  {totalPosts !== 1 ? (
-                    totalPosts !== 0 ? (
-                      <span
-                        style={{
-                          fontWeight: "normal",
-                          opacity: totalPosts === 0 ? "0.5" : "1",
-                        }}
-                      >
+          {props.content &&
+            props.content.map((item) => {
+              let totalPosts = item.threads.length;
+              return (
+                <EntityLi key={item.subjectName} bgcolor="cornsilk">
+                  <a href={"/subject/" + item.subjectId}>{item.subjectName}</a>
+                  <EntityParam right="30px">
+                    {totalPosts !== 1 ? (
+                      totalPosts !== 0 ? (
                         <span
                           style={{
-                            fontWeight: "bold",
+                            fontWeight: "normal",
                             opacity: totalPosts === 0 ? "0.5" : "1",
                           }}
                         >
-                          {totalPosts}
-                        </span>{" "}
-                        мислења
-                      </span>
-                    ) : (
-                      <span
-                        style={{
-                          fontWeight: "normal",
-                          opacity: totalPosts === 0 ? "0.5" : "1",
-                        }}
-                      >
+                          <span
+                            style={{
+                              fontWeight: "bold",
+                              opacity: totalPosts === 0 ? "0.5" : "1",
+                            }}
+                          >
+                            {totalPosts}
+                          </span>{" "}
+                          мислења
+                        </span>
+                      ) : (
                         <span
                           style={{
-                            fontWeight: "bold",
+                            fontWeight: "normal",
                             opacity: totalPosts === 0 ? "0.5" : "1",
                           }}
                         >
-                          {totalPosts}
-                        </span>{" "}
-                        мислења
+                          <span
+                            style={{
+                              fontWeight: "bold",
+                              opacity: totalPosts === 0 ? "0.5" : "1",
+                            }}
+                          >
+                            {totalPosts}
+                          </span>{" "}
+                          мислења
+                        </span>
+                      )
+                    ) : (
+                      <span style={{ fontWeight: "normal" }}>
+                        <span style={{ fontWeight: "bold" }}>{totalPosts}</span>{" "}
+                        мислење
                       </span>
-                    )
-                  ) : (
-                    <span style={{ fontWeight: "normal" }}>
-                      <span style={{ fontWeight: "bold" }}>{totalPosts}</span>{" "}
-                      мислење
-                    </span>
-                  )}
-                </EntityParam>
-              </EntityLi>
-            );
-          })}
+                    )}
+                  </EntityParam>
+                </EntityLi>
+              );
+            })}
         </EntityUl>
       </SubjectsAccordionDiv>
Index: reactapp/src/Components/UserHeader.js
===================================================================
--- reactapp/src/Components/UserHeader.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Components/UserHeader.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -4,6 +4,29 @@
 import Logout from "./Logout";
 
-function UserHeader({ user, userLoaded }) {
-  return userLoaded ? (
+function UserHeader({}) {
+  const [user, setUser] = useState(null);
+  const [loadedUser, setLoadedUser] = useState(false);
+  const [fetchError, setFetchError] = useState(false);
+
+  useEffect(() => {
+    const url = `http://192.168.0.17:8080/secure/currentUser`;
+
+    const fetchUser = async () => {
+      try {
+        const response = await axios.get(url, { withCredentials: true });
+        var cyclicGraph = await response.data;
+        var jsogStructure = JSOG.encode(cyclicGraph);
+        cyclicGraph = JSOG.decode(jsogStructure);
+        setUser(cyclicGraph);
+        setLoadedUser(true);
+      } catch (error) {
+        setFetchError(true);
+      }
+    };
+
+    fetchUser();
+  }, []);
+
+  return loadedUser ? (
     <div style={{ float: "left", marginTop: 20, marginLeft: 40 }}>
       Најавен/а: <a href="/user_dashboard">{user.username}</a> <Logout />{" "}
Index: reactapp/src/Pages/Faculty.js
===================================================================
--- reactapp/src/Pages/Faculty.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Pages/Faculty.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -60,5 +60,5 @@
   }, [params.facultyId]);
 
-  return loadedProfessors ? (
+  return loadedProfessors && professors.length != 0 ? (
     entityType === 0 ? (
       <>
@@ -114,5 +114,5 @@
                     {professor.professorName}
                   </a>
-                  <EntityParam>
+                  <EntityParam right="30px">
                     {totalPosts !== 1 ? (
                       totalPosts !== 0 ? (
@@ -168,4 +168,5 @@
         <>
           <CurrentPageNav>
+            &#187;{" "}
             <a
               href={
@@ -175,5 +176,5 @@
               {professors[0].faculty.university.universityName}
             </a>{" "}
-            / <a href="#">{professors[0].faculty.facultyName}</a>
+            &#187; <a href="#">{professors[0].faculty.facultyName}</a>
           </CurrentPageNav>
           <ProfessorCard>
@@ -221,5 +222,5 @@
       )
     )
-  ) : !fetchError ? (
+  ) : !fetchError && !loadedProfessors ? (
     <div>
       <p style={{ marginTop: "140px" }}>се вчитува...</p>
Index: reactapp/src/Pages/Home.js
===================================================================
--- reactapp/src/Pages/Home.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Pages/Home.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -24,5 +24,5 @@
       </a>{" "}
       <Search />
-      {auth && <UserHeader user={user} userLoaded={userLoaded} />}
+      {auth && <UserHeader />}
       <div style={{ marginTop: "140px" }}></div>
       <Outlet />
Index: reactapp/src/Pages/Login.js
===================================================================
--- reactapp/src/Pages/Login.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Pages/Login.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -35,5 +35,8 @@
     if (!response.request.responseURL.includes("error")) {
       // ako NE redirektira na /login?error
-      Cookies.set("JSESSIONID", response.data.sessionId);
+      var in30Minutes = 1 / 48;
+      Cookies.set("JSESSIONID", response.data.sessionId, {
+        expires: in30Minutes,
+      });
       setAuth(true);
       setErrMsg("");
Index: reactapp/src/Pages/Professor.js
===================================================================
--- reactapp/src/Pages/Professor.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Pages/Professor.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -25,20 +25,21 @@
 import { CurrentPageNav } from "../Components/Styled/Main.style";
 
-function Professor(user, userLoaded) {
+function Professor() {
   let params = useParams();
+  let navigate = useNavigate();
 
-  let [professor, setProfessor] = useState(null);
-  let [loaded, setLoaded] = useState(null);
-  let [postModalDisplay, setPostModalDisplay] = useState("none");
-  let navigate = useNavigate();
+  const [professor, setProfessor] = useState(null);
+  const [loadedProfessor, setLoadedProfessor] = useState(false);
+
+  const [postModalDisplay, setPostModalDisplay] = useState("none");
   const { auth, setAuth } = useContext(AuthApi);
-  const [postTitle, setPostTitle] = useState("");
   const [postContent, setPostContent] = useState("");
   const [fetchError, setFetchError] = useState(false);
+  const [errorMessage, setErrorMessage] = useState("");
 
   useEffect(() => {
     const url = `http://192.168.0.17:8080/public/professor/${params.professorId}`;
 
-    const fetchData = async () => {
+    const fetchProfessor = async () => {
       try {
         const response = await fetch(url);
@@ -47,5 +48,5 @@
         cyclicGraph = JSOG.decode(jsogStructure);
         setProfessor(cyclicGraph);
-        setLoaded(true);
+        setLoadedProfessor(true);
       } catch (error) {
         setFetchError(true);
@@ -53,5 +54,5 @@
     };
 
-    fetchData();
+    fetchProfessor();
   }, [params.professorId]);
 
@@ -71,21 +72,20 @@
     e.preventDefault();
 
-    const response = await axios(
-      `http://192.168.0.17:8080/secure/professor/${professor.professorId}/addOpinion`,
-      {
-        method: "post",
-        data: {
-          title: postTitle,
-          content: postContent,
-        },
-        withCredentials: true,
-      }
-    );
-
-    window.location.reload(false);
-  };
-
-  const handleTitleChange = (e) => {
-    setPostTitle(e.target.value);
+    if (!postContent.length < 1) {
+      const response = await axios(
+        `http://192.168.0.17:8080/secure/professor/${params.professorId}/addOpinion`,
+        {
+          method: "post",
+          data: {
+            content: postContent,
+          },
+          withCredentials: true,
+        }
+      );
+      setErrorMessage("");
+      window.location.reload(false);
+    } else {
+      setErrorMessage("Полето за содржина не смее да биде празно");
+    }
   };
 
@@ -94,5 +94,5 @@
   };
 
-  if (loaded) {
+  if (loadedProfessor) {
     return (
       <div>
@@ -120,5 +120,5 @@
           </div>
         </ProfessorCard>
-        <div style={{ height: "20px", marginBottom: "30px" }}>
+        <div style={{ height: "20px", marginBottom: "50px" }}>
           <h3
             style={{
@@ -146,13 +146,4 @@
             <form onSubmit={handlePostSubmit}>
               <ModalBody>
-                <label htmlFor="title">
-                  <b>Наслов</b>:
-                  <ModalInput
-                    id="title"
-                    type="text"
-                    value={postTitle}
-                    onChange={handleTitleChange}
-                  />
-                </label>
                 <label htmlFor="content">
                   <b>Содржина</b>:
@@ -166,4 +157,9 @@
                 </label>
               </ModalBody>
+              <p
+                style={{ color: "red", marginLeft: "15px", marginTop: "10px" }}
+              >
+                {errorMessage}
+              </p>
               <ModalFooter type="submit">ОБЈАВИ</ModalFooter>
             </form>
@@ -172,9 +168,5 @@
 
         <div className="opinionTree">
-          <OpinionTree
-            professor={professor}
-            user={user}
-            userLoaded={userLoaded}
-          />
+          <OpinionTree professor={professor} />
         </div>
         <Outlet />
Index: reactapp/src/Pages/Registration.js
===================================================================
--- reactapp/src/Pages/Registration.js	(revision 8d831804abcee99d72c207c57a8f16e54b1329a2)
+++ reactapp/src/Pages/Registration.js	(revision c68150fac8ab8e6f5dc5b8b2a9cd73d391dc1aa7)
@@ -1,3 +1,3 @@
-import React, { useRef, useState, useEffect } from "react";
+import React, { useRef, useState, useEffect, useContext } from "react";
 import axios from "../api/axios";
 import {
@@ -7,7 +7,10 @@
   RequiredAsterisk,
 } from "../Components/Styled/Login.style";
+import { Navigate } from "react-router-dom";
+import AuthApi from "../api/AuthApi";
 const REGISTRATION_URL = "/registration";
 
 const Registration = () => {
+  const { auth, setAuth } = useContext(AuthApi);
   const userRef = useRef();
   const errRef = useRef();
@@ -50,5 +53,7 @@
     useState(0);
 
-  return registrationSuccessful === false ? (
+  return auth ? (
+    <Navigate to="/user_dashboard" />
+  ) : registrationSuccessful === false ? (
     <div
       style={{
